/*
 * i2c.c
 *
 * Author: R9OFG
 * Ver - 2.00
 */ 

#include "i2c.h"

/*  */

void	I2C_init()					//  i2c
{
	/*
	     i2c   400 
	    TWBR = ((F_CPU/F_SCL)-16)/2 = ((16000/100)-16)/2 = 72  0x48
	*/
	TWBR = 0x48;
	TWSR = 0;
	TWDR = 0xFF;
	PRR  = 0;
}

uint8_t I2C_start()					//i2c 
{
	//  
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN);
	//   TWINT.      
	while (!(TWCR & (1<<TWINT))) ;
	//
	return (TWSR & 0xF8);
}

void	I2C_stop()					//i2c 
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	while ((TWCR & (1<<TWSTO))) ;
}

uint8_t I2C_byte_send(uint8_t data)	//i2c  
{
	TWDR = data;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT))) ;
	return (TWSR & 0xF8);
}

/*   */